<template>
  <section>
    <h4>Group words with same set of characters.</h4>
    <div id="wordsInputBox">
      <p>Enter words:</p>
      <textarea style="width: 100%" rows="10" cols="50" v-model="words"></textarea>
    </div>
    <button @click="sortingGroup">Sorting group</button>
    <div id="resultBox" v-show="groupWords.length > 0">
      <p>Result group:</p>
      <div class="result">
        <div v-for="(group, groupIndex) in groupWords" :key="groupIndex">
          {{`${groupIndex + 1}. ${group.word}`}}
        </div>
      </div>
    </div>
  </section>
</template>

<script>
  export default {
    data() {
      return {
        words: '',
        groupWords: []
      }
    },
    methods: {
      sortingGroup() {
        const vm = this
        vm.groupWords = []
        const wordArray = vm.words.replace(/\n/ig, ',').replace(/-/g,',').replace(/[&\/\\#,^_+()$~%'"*?<>!@{}; .:=|0-9]+/g, ',').toUpperCase().split(',')
        let newWordList = []
        let count = 0
        wordArray.map((word) => {
          newWordList.push( { word: word, checked: false} )
        })
        newWordList.map(newWord => {
          let newData = Array.from(newWord.word)
          count = 0
          if (!newWord.checked && newWord.word) {
            let findWordIndex = newWordList.filter(wordIndex => wordIndex.word.length === newWord.word.length && !wordIndex.checked)
            if (findWordIndex.length > 0) {
              findWordIndex.map((wordSelect) => {
                newData.map((lettle) => {
                  if (wordSelect.word.search(lettle) > -1) {
                    count += 1
                    if (wordSelect.word.length === count) {
                      const indexWord = newWordList.findIndex(e => e.word === wordSelect.word && !e.checked)
                      newWordList[indexWord].checked = true
                      count = 0
                    }
                  }
                })
              })
              let resultObject = []
              findWordIndex.filter((wordList) => {
                wordList.checked ? resultObject.push(wordList.word) : ''
              })
              vm.groupWords.push({ word: resultObject.toString().replace(/[,]/g, ' - ')})
            }  
          }         
        })
      }
    }
  }
</script>

<style scoped>
  textarea {
    border-radius: 4px;
    padding: 5px 10px 5px 10px;
    outline: none;
  }
  textarea:focus {
    border: 1px solid #36a3f7 !important;
    border-radius: 4px;
  }
  button {
    margin: 10px 0;
    cursor: pointer;
    outline: none;
    border: none !important;
    padding: 5px;
    border-radius: 5px;
    background: #3b8aff;
    color: white;
    box-shadow: 0px 3px 1px -2px rgba(0, 0, 0, 0.2),
    0px 2px 2px 0px rgba(0, 0, 0, 0.14),
    0px 1px 5px 0px rgba(0, 0, 0, 0.1)
  }
  .result {
    border: 1px solid;
    padding: 10px 20px;
  }
</style>